/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include "HTMLretrieve.h"
#include <iostream>
#include <string>
#include <thread>
#include <fstream>
#include <curl/curl.h>
#include "sq.h"
#include "sql.h"
void sq::double_points(string& link, string url){

	size_t point = url.rfind(".");
	size_t size = url.size()-5;
	if(point >= size)
		delete_html(url);
	
	size_t d_b=link.find(":");
	if(link[0]!='/' && link[0]!='.' && d_b==string::npos){
		string new_page;
		new_page = url + link;
		this->comparing(new_page);
	}
	if(link[0]=='h' && link[1]=='t' && d_b !=string::npos){
		this->comparing(link);
	}
	if(link[0]=='.' && link[1]=='/' && link[2]!='.'){
		string local_link;
		local_link=link.substr(2);
		string new_page;
		new_page = url + local_link;
		this->comparing(new_page);
	}
	if(link[0]=='/' && link[1]!='/'){
		string domain;
		domain=obtain_domain(link);
		string new_page;
		new_page = domain + link;
		this->comparing(new_page);
	}
	if(link[1]=='/'){
		size_t point =link.find('.');
		if(point!=string::npos){
			string enlace_control(link);
			++point;
			enlace_control=enlace_control.substr(point,link.size()-point);
			size_t point2 =enlace_control.find('.');
			if(point2!=string::npos){
				size_t first =url.find("/");
		
				if(link[0]=='/' && first==5){
					string enlace(url);
					enlace=enlace.substr(0,5);
					//link=link.substr(2);
					string new_page;
					new_page = enlace + link;
					this->comparing(new_page);
				}
				if(link[0]=='/' && first==6){
					string enlace(url);
					enlace=enlace.substr(0,6);
					string new_page;
					new_page = enlace + link;
					this->comparing(new_page);
				}
			}
		}
	}
	if(link[0]=='.' && link[1]=='.' && link[2]=='/' && link[3]!='.'){
		string alternative;
		alternative=previous_folder(link);
		string local_link;
		local_link=link.substr(3);
		string new_page;
		new_page = alternative + local_link;
		//if(this->verbose==1)
			//cout << new_page << endl;
		this->comparing(new_page);
	}
}

void sq::delete_html(string& link){
	size_t location = link.find_last_of('/');
	++location;
	link=link.substr(0,location);
	//if(this->verbose==1)
		//cout << url <<endl;
}
string sq::obtain_domain(string& link){
	string domain(url);
	size_t slash=domain.find("//");
	slash+=2;
	slash=domain.find("/",slash);
	domain=domain.substr(0,slash);
	//if(this->verbose==1)
		//cout << this->domain <<endl;
	return domain;
}
string sq::previous_folder(string& link){
	string alternative(url);
	size_t size=alternative.size();
	--size;
	if(alternative[size]=='/'){
		size_t slash=alternative.rfind("/",--size);
		alternative=alternative.substr(0,++slash);
		
		//if(this->verbose==1)
			//cout << this->alternative << endl;
	}
	return alternative;
}
void sq::comparing(string& link){
	//auto it=this->links.find(link);
	//if(it==this->links.end()){

		size_t slash=link.find("//");
		slash+=2;
		size_t slash2=link.find("/",slash);
		string domain;
		domain=link.substr(0,slash2);
		domain=domain.substr(slash);
		size_t point=domain.rfind(".");

		domain=domain.substr(0,point);
		size_t point_2=domain.rfind(".");
		//cout << domain << endl;
		if(point_2!=string::npos){
			domain=domain.substr(++point_2);
			//if(this->verbose==1)
			//	cout << domain << endl;
		}
		auto et=this->banned.find(domain);
		if(et==this->banned.end()){
			this->insert_link(link);
		}
	//}
}
void sq::insert_link(string& link){
	if(lock==0){
		if((this->ssl_strict==1 && link[4]=='s') or this->ssl_strict==0){
			//this->links.insert(link);
			control=sqlite_insert(link.c_str()," ", this->name.c_str());

			if(control==0){
				++this->position_w;
			}

			if(this->verbose==1)
				cout << "Enlace introducido: "<<link<< endl;

		}
	}else{
		if((this->ssl_strict==1 && link[4]=='s') or this->ssl_strict==0){
			size_t lo=link.find(this->locked.c_str());
			if(lo!=string::npos){
				//this->links.insert(link);
				int control;
				control=sqlite_insert(link.c_str()," ",this->name.c_str());

				if(control==0){
					++this->position_w;
				}

				if(this->verbose==1)
					cout << "Enlace introducido: "<<link<< endl;
			}
		}
	}
}
