/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include "sq.h"

using namespace std;

void sq::load_config(){
	ifstream queue_saved("seer.conf");
	string line;
	int i=0;
	while(getline(queue_saved,line)){
		switch(i){
			case 0:this->name=line;break;
			case 1:this->verbose=stoi(line);break;
			case 2:this->isCrawling=line;break;
		}
		i++;

	}
	if(i<2){
		ofstream config("seer.conf");
		this->name="sq1";
		this->verbose=1;
		this->isCrawling="true";
		config << this->name << endl;
		config << this->verbose << endl;
		config << this->isCrawling << endl;
		config.close();

	}
	queue_saved.close();
}
