/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <queue>
#include <string>
#include <thread>
#include <fstream>
#include <sstream>
#include <set>
#include "sq.h"
#include <string.h>
#include "sql.h"
#include "HTMLretrieve.h"
using namespace std;

void sq::thread_crawl(){
	thread (&sq::crawl_bucle, this).detach();
}
/*
void sq::load_set(){
	ifstream set(this->name.c_str());
	string line;
	while(getline(set,line))
		this->links.insert(line);
	if(this->verbose==1)
		cout << "Set cargado."<<endl;
}
*/
void sq::crawl_bucle(){
	int wi=0;
	int fails=0;
	while(this->isCrawling=="true" && this->position_w >= this->position && fails < this->max_fails){
		++wi;
		string line;
		sqlite_select(this->position, this->name, this->url);
		if(wi>=100){
			string file;
			file=this->name + ".conf";
			ofstream save(file.c_str());
			string save_a[12];
			string line;
			save_a[0]= this->name;
			save_a[1]= to_string(this->max_url_size);
			save_a[2]= to_string(this->min_url_size);
			save_a[3]= to_string(this->ssl_strict);
			save_a[4]= to_string(this->position);
			save_a[5]= this->isCrawling;
			save_a[6]= to_string(this->max_fails);
			save_a[7]= to_string(this->delay);
			save_a[8]= to_string(this->lock);
			save_a[9]= this->locked;
			save_a[10]= to_string(this->daemon);
			save_a[11]=to_string(this->position_w);
			for(int i=0;i<=11;i++){
				line += save_a[i] + "\n";
			}
			save << line;
			save.close();
			wi=0;
/*
			int size=this->links.size()-1;
			if(size>=this->max_urls){
				limit_queue();
			}
*/
		}
		if(this->verbose==1){
			cout <<"----------------"<< endl;
			cout << "Enlace principal del primer hilo: "<< this->url << endl;
		}
		string robot=this->url;
		size_t point=robot.find(".");
		point=robot.find("/",point);
		if(point!=string::npos){
			robot=robot.substr(0,point+1);
			robot+="robots.txt";
		
			this->double_points(robot,this->url);
		}	
		const char * url = this->url.c_str();
		int fail=this->retrieve_html(url);
		if(fail==0)
			++fails;
		else
			fails=0;
		++this->position;
	}
	if(this->verbose==1)
		cout << "Terminó el bucle de forma inesperada" <<endl;
}
/*
void sq::limit_queue(){
	
	int i=0;
	int size_pre=this->links.size();
	for(unordered_set<string>::iterator it=this->links.begin(); it!=this->links.end() && i!=-1; ++it){
		if(i>=this->max_urls){
			this->links.erase ( this->links.begin(), it );
			i=-2;
		}
		++i;
	}
	int size_post=this->links.size();

		cout << "Se han eliminado " << size_post-size_pre << endl;
}
*/
