/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <curl/curl.h>
#include <iostream>
#include <string>
#include <fstream>
#include <set>
#include "HTMLretrieve.h"
#include "finder.h"
#include "sq.h"
#include "sql.h"
using namespace std;


int main(int argc, char *argv[]){

	sq user;
	user.isCrawling="true";
	user.position_w=1;
	user.load_config();
	string load(argv[1]);
	
	ifstream crawled_links("banned");
	string line;
	while(getline(crawled_links,line)){
		user.banned.insert(line);
	}
	crawled_links.close();

	if(load!="-l"){
		if(load=="-h"){
			cout << "Ayuda para el uso de Seer" << endl;
			cout << "se -a URL -- Hace funcionar a Seer sin posibilidad de modificar opciones"<< endl;
			cout << "se -l -- Carga y devuelve a Seer a un estado guardado" << endl;
			cout << "se URL -- Versión con una interfaz sencilla para usuarios"<< endl;
			cout << "se -h -- Esta misma pantalla"<< endl;
			cout << "Para más ayuda consulta la página de referencia: https://autistici.org/alkeon/"<< endl;
		}else{
			if(load=="-a"){
				user.daemon=1;
				user.create_sq();
				user.url.assign(argv[2]);
				sqlite_create(user.name);
				sqlite_insert(argv[2], " ",user.name);

				++user.position_w;
				user.crawl_bucle();
				
			}else{
				user.daemon=0;
				user.create_sq();
				user.url.assign(argv[1]);
				sqlite_create(user.name);
				sqlite_insert(argv[1], " ",user.name);
				++user.position_w;
				user.thread_crawl();
				
			}
		
		}
	}

	if(load=="-l"){
		//user.load_set();
		user.load_sq();
		if(user.daemon==0){
			user.thread_crawl();
		}else{
			user.crawl_bucle();
		}
	}
	
	if(user.verbose==1 && user.daemon==0){
		int i=0;
		while(i==0){
			int eleccion;
			cout << "1.- Para/Inicia el crawler"<<endl;
			cout << "2.- Indexa dominios"<<endl;
			cout << "3.- Añade enlace"<< endl;

			cout << "5.- Cambia de Araña"<< endl;
			cout << "6.- Mezcla de Arañas"<< endl;
			cout << "7.- Importa marcadores"<< endl;
			cout << "10.- MOC OUT"<< endl;
			cin >> eleccion;
		
			cout << user.isCrawling << endl;
			switch(eleccion){
				case 10:i=1;break;
				case 7:user.import_bookmarks();break;
				case 6:user.mix_sq();break;
				case 5:user.change_sq();break;
				case 3:{
					user.isCrawling="false";
					char url[300];
					cin >> url;
					user.retrieve_html(url);
				};break;
				case 2:{
					string word;
					cout << "\n\n\n\n\t\t\tSeer\n\n\n\n\t\t";
					cin >> word;
					sqlite_se(user.name,word);
					
				};break;
				case 1:{
					if(user.isCrawling=="true"){
						user.isCrawling="false";
		
					}else{
						user.isCrawling="true";
						user.thread_crawl();
					}
				};break;
			}
		}
	}
}



