/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <queue>
#include <sstream>
#include <fstream>
#include "sq.h"
#include "sql.h"
using namespace std;

void sq::parse(std::string data,std::string url){
	std::istringstream doc(data);
	std::string line;
	while(getline(doc,line)){
		size_t ref=line.find("href=\"");
		if(ref!= std::string::npos){
			ref+=6;
			line=line.substr(ref);
			size_t first=line.find("\"");
			if(first!= std::string::npos ){
				line=line.substr(0,first);
				ref=line.find(";");
				if(ref== std::string::npos){
					size_t hash=line.find("#");
					if(hash==std::string::npos){
						size_t quest=line.find("?");
						if(quest==std::string::npos){
							int size =line.size();
							if(size < this->max_url_size && size > this->min_url_size){
									std::cout << line << std::endl;
									this->double_points(line,url);
							}
						}
					}
				}
			}
		}else{
			size_t second =line.find("<title>");
			if(second!= std::string::npos){
				second+=7;
				line=line.substr(second);
			//std::cout << line << std::endl;
				size_t tercero=line.find("</title>");
				if(tercero!= std::string::npos){
					line=line.substr(0,tercero);
			
					if(line.size() < 500 ){
						//auto it=this->links.find(this->url);
							//if(it==this->links.end()){
								sqlite_up(this->name,this->position,line);
							//}
					}
				}
			}else{
				size_t third=line.find("<loc>");
				if(third!= std::string::npos){
					third+=5;
					line=line.substr(third);
					size_t fourth=line.find("<");
					line=line.substr(0,fourth);
					this->double_points(line,url);
				}else{
					size_t ref=line.find("Sitemap: ");
					size_t ht=line.find("http");
					if(ref!= std::string::npos && ht != std::string::npos){
						ref+=9;
						line=line.substr(ref);
						this->double_points(line,url);
					}
				}
			}
		}
	}
	doc.str(std::string());
}
