/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include "sq.h"
#include <fstream>
#include <sstream>
using namespace std;
sq::sq(){}
sq::~sq(){}

void sq::create_sq(){

	if(this->daemon==1){
		this->isCrawling="true";
		this->name="sq1";
		this->max_url_size=1000;
		//this->max_urls=10000;
		this->min_url_size=13;
		this->ssl_strict=0;
		this->delay=2;
		this->position=1;
		this->lock=0;
		this->locked=":";
		this->position_w=1;
		this->max_fails=10;
	}else{
		int aux;
		//Crawling
		cout << "¿Quieres que al empezar el programa se inicie la araña?"<<std::endl;
		cout << "1.- Sí"<< endl;
		cout << "2.- No"<< endl;
		cin >> aux;
		if(aux==1){
			this->isCrawling="true";
		}else{
			this->isCrawling="false";
		}
		this->position=1;
		cout << "Escribe el nombre del archivo donde se guardarán los enlaces" << endl;
		cin >> this->name;

		//cout << "Escribe el tamaño máximo de los enlaces en la cola" << endl;
		//cin >> this->max_urls;

		cout << "Escribe el número máximod errores consecutivos" << endl;
		cin >> this->max_fails;

		cout << "Escribe el tamaño máximo de los enlaces" << endl;
		cin >> this->max_url_size;

		cout << "Escribe el tamaño mínimo de los enlaces" << endl;
		cin >> this->min_url_size;

		cout << "¿Preferencia de enlaces seguros?" << endl;
		cin >> this->ssl_strict;

		cout << "Escribe tiempo de espera entre enlaces" << endl;
		cin >> this->delay;

		cout << "¿Quieres mantener los enlaces bloqueados respecto de un dominio?" << endl;
		cout << "0.- No"<< endl;
		cout << "1.- Sí"<< endl;
		cin >> this->lock;
		if(this->lock==1){
			cout << "Enlace de control" << endl;
			cin >> this->locked;
		}else{
			this->locked=":";
		}
	}

	std::string line;
	std::string file;
	file=this->name + ".conf";
	std::ofstream save(file.c_str());
	std::string save_a[12];
	save_a[0]= this->name;
	save_a[1]= to_string(this->max_url_size);
	save_a[2]= to_string(this->min_url_size);
	save_a[3]= to_string(this->ssl_strict);
	save_a[4]= to_string(this->position);
	save_a[5]= this->isCrawling;
	save_a[6]= to_string(this->max_fails);
	save_a[7]= to_string(this->delay);
	save_a[8]= to_string(this->lock);
	save_a[9]= this->locked;
	save_a[10]=to_string(this->daemon);
	save_a[11]=to_string(this->position_w);
	for(int i=0;i<=11;i++){
		line += save_a[i] + "\n";
	}
	save << line;
	std::ofstream save_g("seer.conf");
	save_g << this->name  << std::endl;
	save_g << this->verbose << std::endl;
	save_g << this->isCrawling << std::endl;
	save_g.close();
}
void sq::load_sq(){
	std::string file;
	std::string line;
	file=this->name + ".conf";
	ifstream in(file.c_str());
	for(int i=0;getline(in,line);++i){
		switch(i){
			case 0:this->name=line;break;
			case 1:this->max_url_size = stoi(line);break;
			case 2:this->min_url_size = stoi(line);break;
			case 3:this->ssl_strict = stoi(line);break;
			case 4:this->position = stoi(line);break;
			case 5:this->isCrawling = line;break;
			case 6:this->max_fails = stoi(line);break;
			case 7:this->delay = stoi(line);break;
			case 8:this->lock = stoi(line);break;
			case 9:this->locked = line;break;
			case 10:this->daemon = stoi(line);break;
			case 11:this->position_w = stoi(line);break;
		}
	}
	in.close();
}
void sq::change_sq(){
	std::cout << "Escriba el nombre de la base" << std::endl;
	std::cin >> this->name;
	std::string file;
	std::string line;
	file=this->name + ".conf";
	ifstream in(file.c_str());
	for(int i=0;getline(in,line);++i){
		switch(i){
			case 0:this->name=line;break;
			case 1:this->max_url_size = stoi(line);break;
			case 2:this->min_url_size = stoi(line);break;
			case 3:this->ssl_strict = stoi(line);break;
			case 4:this->position = stoi(line);break;
			case 5:this->isCrawling = line;break;
			case 6:this->max_fails = stoi(line);break;
			case 7:this->delay = stoi(line);break;
			case 8:this->lock = stoi(line);break;
			case 9:this->locked = line;break;
			case 10:this->daemon = stoi(line);break;
			case 11:this->position_w = stoi(line);break;
		}
	}
	in.close();
}

void sq::mix_sq(){
	std::cout << "Escriba el nombre de la SQ principal" << std::endl;
	std::cin >> this->name;
	std::string name2;
	std::cout << "Escriba el nombre de la SQ que será añadida" << std::endl;
	std::cin >> name2;
	std::ifstream previous(name2.c_str());
	std::ofstream mix(this->name.c_str(),std::ofstream::app);
	std::string line;
	while(getline(previous,line)){
		mix << line << std::endl;
	}
	mix.close();
	previous.close();
}
void sq::import_bookmarks(){
	std::cout << "Escriba el nombre del archivo HTML" << std::endl;
	std::string name2;
	std::cin >> name2;
	std::ifstream previous(name2.c_str());

	std::string line;
	std::string complete=" ";
	while(getline(previous,line)){
		complete += line + "\n";
	}
	this->parse(complete);
	previous.close();
}
