
#include "SDL.h"
#include "SDL_image.h"

int main(int argc, char * args[]){
	//Nueva ventana
	SDL_Window* pWindow= SDL_CreateWindow("Imagen",SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, 1000, 1000, SDL_WINDOW_SHOWN);
	//Nuevo render relacionado con la ventana
	SDL_Renderer* pRenderer = SDL_CreateRenderer(pWindow, -1,0);
	SDL_Rect destinationRectangle;
	SDL_Rect sourceRectangle;
	//Color del fondo
	SDL_SetRenderDrawColor(pRenderer, 0, 0, 0, 255);
	//Eliminar restos en el render
	SDL_RenderClear(pRenderer);
	//Cargamos la imagen en una superficie
	SDL_Surface* pTempSurface = IMG_Load("image.png");
	//Pasar la superficie a una textura (Permite aceleración por hardware)
	SDL_Texture * pTexture = SDL_CreateTextureFromSurface(pRenderer,
	pTempSurface);
	SDL_FreeSurface(pTempSurface);
	//Tamaño de la imagen cargado en sourceRectangle
	SDL_QueryTexture(pTexture, NULL, NULL, &sourceRectangle.w, &sourceRectangle.h);
	destinationRectangle.x = sourceRectangle.x =0;
	destinationRectangle.y = sourceRectangle.y = 0;
	destinationRectangle.w = sourceRectangle.w;
	destinationRectangle.h = sourceRectangle.h;
	//Cargar en el render la imagen con los SDL_Rect para definir tamaño
	SDL_RenderCopy(pRenderer, pTexture, &sourceRectangle,
&destinationRectangle);
	//Renderizar todo
	SDL_RenderPresent( pRenderer );
	//Paro de 2000
	SDL_Delay(2000);
	SDL_DestroyTexture(pTexture);
	SDL_RenderClear(pRenderer);
	SDL_DestroyWindow(pWindow);
	SDL_Quit();
}
