
#include "SDL.h"
#include "SDL_image.h"
#include <iostream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;

//Button constants
const int BUTTON_WIDTH = 300;
const int BUTTON_HEIGHT = 200;
const int TOTAL_BUTTONS = 4;


int main( int argc, char* args[] )
{
	SDL_Init( SDL_INIT_EVERYTHING );

	SDL_Window* pWindow= SDL_CreateWindow("Posición del ratón",SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, 640, 480, SDL_WINDOW_SHOWN);

	SDL_Renderer* pRenderer = SDL_CreateRenderer(pWindow, -1,0);

	SDL_SetRenderDrawColor(pRenderer, 0, 0, 0, 255); 
	SDL_RenderClear(pRenderer);

	SDL_Surface* pTempSurface = IMG_Load("x.png");

	SDL_Texture* pTexture = SDL_CreateTextureFromSurface(pRenderer,
	pTempSurface);

	SDL_FreeSurface(pTempSurface);
	SDL_RenderCopy(pRenderer, pTexture, NULL,
NULL);
	//Creador del controlador de eventos de SDL
	SDL_Event e;
	int quit=true;
	while(quit){
		//Lista de eventos (Pollevent)
	 	while( SDL_PollEvent( &e ) != 0 ) {
			SDL_RenderPresent( pRenderer );
			//Comprobar distintos tipos
			switch( e.type )
			{
				//Tipo que se define cuando se pulsa una tecla
				case SDL_MOUSEMOTION:{
					int x, y;
					SDL_GetMouseState( &x, &y );
					std::cout <<"Posición en x:"<< x <<"\nPosición en y:" << y << std::endl;
				break;
				}
				//Tipo que se define cuando se pulsa la cruz de cerrar ventana
				case SDL_QUIT:
					quit=false;
				break;
			
			}
		}
	
	}
	//Descarga de objetos
	SDL_DestroyTexture(pTexture);
	SDL_RenderClear(pRenderer);
	SDL_DestroyWindow(pWindow);
	SDL_Quit();
}
