#include "SDL.h"
#include "SDL_ttf.h"
#include <iostream>
#include <sstream>
const int SCREEN_WIDTH = 640;
const int SCREEN_HEIGHT = 480;
Uint32 mStartTicks = 0;

int main(int argc, char* argv[]){
	SDL_Init( SDL_INIT_EVERYTHING);
	//Carga de True Type Font
	TTF_Init();
	SDL_Window * gWindow = SDL_CreateWindow( "Pausar el tiempo", 
		SDL_WINDOWPOS_UNDEFINED,
		SDL_WINDOWPOS_UNDEFINED,
		SCREEN_WIDTH, 
		SCREEN_HEIGHT,
		SDL_WINDOW_SHOWN );
	SDL_Renderer * gRenderer=SDL_CreateRenderer(gWindow,-1,0);
	TTF_Font * gFont = TTF_OpenFont( "tnfc.ttf", 28 );
	SDL_Event e;
	Uint32 startTime = 0;
	
	bool quit = false;
	
	SDL_Color textColor = { 0, 0, 0, 255 };
	std::stringstream timeText;
	while( !quit ){
		
		while( SDL_PollEvent( &e ) != 0 ){
			if( e.type == SDL_QUIT ){
				quit = true;
			}
			else if( e.type == SDL_KEYDOWN ){

				 if( e.key.keysym.sym == SDLK_p ){	
					//Actualizar el tiempo al pulsar la letra "p"
						mStartTicks = SDL_GetTicks();
				}
			
			}
		}
		timeText.str( "" );
		timeText << "Segundos desde que la anterior vez " <<  mStartTicks ; 
		//Hace una superficie del texto
		SDL_Surface* textSurface = TTF_RenderText_Solid( gFont, timeText.str().c_str(), textColor );
		//Pasar de una superficie a una textura
    	SDL_Texture * mTexture = SDL_CreateTextureFromSurface( gRenderer, textSurface);
		SDL_Rect* clip = NULL;

		SDL_SetRenderDrawColor( gRenderer, 0xFF, 0xFF, 0xFF, 0xFF );
		SDL_RenderClear( gRenderer );
				
		SDL_Rect renderQuad = { ( SCREEN_WIDTH - 320 ) / 2, 0, 400, 100 };
		SDL_RenderCopy(gRenderer, mTexture, clip,
&renderQuad);
		SDL_RenderPresent( gRenderer );
	}
}
		
	
