/*
*
* This file is part of Seer.
* Copyright (C) <2017>  <alkeon> [alkeon@autistici.org]
   
* Seer is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Seer is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Seer.  If not, see <http://www.gnu.org/licenses/>.
*
*/
#include <iostream>
#include <fstream>
#include <sstream>
#include "sq.h"
using namespace std;

void sq::create_sq(){

	if(this->daemon==1){
		this->isCrawling=1;
		this->name="sq1";
		this->max_url_size=1000;
		this->min_url_size=13;
		this->delay=2;
		this->position=1;
		this->lock=0;
		this->locked="";
		this->max_fails=0;
	}else{
		int aux;
		cout << "¿Quieres que al empezar el programa se inicie la araña?"<<endl;
		cout << "1.- Sí"<< endl;
		cout << "2.- No"<< endl;
		cin >> aux;
		if(aux==1){
			this->isCrawling=1;
		}else{
			this->isCrawling=0;
		}
		this->position=1;
		cout << "Escribe el nombre del archivo donde se guardarán los enlaces" << endl;
		cin >> this->name;

		cout << "Escribe el número máximo de rrores consecutivos" << endl;
		cin >> this->max_fails;

		cout << "Escribe el tamaño máximo de los enlaces" << endl;
		cin >> this->max_url_size;

		cout << "Escribe el tamaño mínimo de los enlaces" << endl;
		cin >> this->min_url_size;

		cout << "Escribe tiempo de espera entre enlaces" << endl;
		cin >> this->delay;

		cout << "¿Quieres mantener los enlaces bloqueados respecto de un dominio?" << endl;
		cout << "0.- No"<< endl;
		cout << "1.- Sí"<< endl;
		cin >> this->lock;
		if(this->lock==1){
			cout << "Enlace de control" << endl;
			cin >> this->locked;
		}else{
			this->locked=":";
		}
	}
	save_sq();
	save_conf();
}
void sq::save_sq(){
	string file=this->name + ".conf";
	ofstream save(file);
	save << "name:"<<this->name << endl;
	save << "max_url_size:"<<to_string(this->max_url_size) << endl;
	save << "min_url_size:"<<to_string(this->min_url_size) << endl;
	save << "position:"<<to_string(this->position) << endl;
	save << "isCrawling:"<<to_string(this->isCrawling) << endl;
	save << "max_fails:"<<to_string(this->max_fails) << endl;
	save << "delay:"<<to_string(this->delay) << endl;
	save << "isLock:"<<to_string(this->lock) << endl;
	save << "locked:"<<this->locked << endl;
	save.close();
}
void sq::load_sq(){
	string file;
	file=this->name + ".conf";
	ifstream queue_saved(file);
	std::string line;
	while(getline(queue_saved,line)){
		size_t points=line.find(":");
		std::string option=line.substr(0,points);
		size_t nm=option.find("name");
		if(nm!= std::string::npos){
			line=line.substr(++points);
			this->name= line;
		}
		size_t max=option.find("max_url_size");
		if(max!= std::string::npos){
			line=line.substr(++points);
			this->max_url_size= stoi(line);
		}
		size_t min=option.find("min_url_size");
		if(min!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->min_url_size= stoi(line);
		}
		size_t pos=option.find("position");
		if(pos!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->position= stoi(line);
		}

		size_t ic=option.find("isCrawling");
		if(ic!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->isCrawling= stoi(line);
		}
		size_t mf=option.find("max_fails");
		if(mf!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->max_fails= stoi(line);
		}
		size_t de=option.find("delay");
		if(de!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->delay= stoi(line);
		}
		size_t lc=option.find("isLock");
		if(lc!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->lock= stoi(line);
		}
		size_t lcd=option.find("locked");
		if(lcd!= std::string::npos){
			line=line.substr(++points);
			//cout << line << endl;
			this->locked= line;
		}
	}
	queue_saved.close();
}
void sq::change_sq(){
	cout << "Escriba el nombre de la base" << endl;
	cin >> this->name;
	load_sq();
}

void sq::import_bookmarks(){
	cout << "Escriba el nombre del archivo HTML" << endl;
	string name;
	cin >> name;
	ifstream previous(name);

	string line;
	string complete;
	while(getline(previous,line)){
		complete += line + "\n";
	}
	this->parse(complete);
	previous.close();
}
