#include <string>
using namespace std;
class uri{
	public:
		uri(const string& complete_url);
		bool valid() const;
		string delete_slug(string path);
		string delete_directory(string path);
		string input(const string& input);
		string scheme() const{return scheme_;};
		string authority() const{return authority_;};
		string path() const{return path_;};
		string query() const{return query_;};
		struct Invalid{
			Invalid(const string& reason):reason_(reason){}
			string reason()const{return reason_;}
			private:
				string reason_;
		};
	private:
		string scheme_;
		string authority_;
		string path_;
		string query_;
};
