
#include "SDL.h"
#include "SDL_image.h"


int main( int argc, char* args[] )
{
	//Iniciamos todas las características de SDL
	SDL_Init( SDL_INIT_EVERYTHING );

	SDL_Window* pWindow= SDL_CreateWindow("Cerrar la ventana",SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, 640, 480, SDL_WINDOW_SHOWN);

	SDL_Renderer* pRenderer = SDL_CreateRenderer(pWindow, -1,0);
	//Cargamos la imagen en PNG
	SDL_Surface* pTempSurface = IMG_Load("x.png");

	SDL_SetRenderDrawColor(pRenderer, 0, 0, 0, 255); 
	SDL_RenderClear(pRenderer);
	
	SDL_Texture* pTexture = SDL_CreateTextureFromSurface(pRenderer,
	pTempSurface);
	SDL_FreeSurface(pTempSurface);
	SDL_RenderCopy(pRenderer, pTexture, NULL,NULL);

	SDL_DestroyTexture(pTexture);
	SDL_Event e;
	int quit=true;
	while(quit){
	 	while( SDL_PollEvent( &e ) != 0 ) { 
			SDL_RenderPresent( pRenderer );
		 	if( e.type == SDL_QUIT ) { 
   					 quit=false;
			}
	 	}
	}
	SDL_RenderClear(pRenderer);
	SDL_DestroyWindow(pWindow);
	SDL_Quit();
}
